% Function to adjust data
%
% Input: data for processing (for example from tensile test)
% Output: adjusted data
%
% (c) Michal Prinosil 2012
%----------------------

function FitData(vstpar)
	if nargin==0 %Funtion FitData without input parametr
		
		Monitor=get(0,'ScreenSize'); % get screen resolution
		
		%Control figur
		F1=figure('Units','Pixels',...
			'Position',[0.5*Monitor(3)-336 0.9*Monitor(4)-157.5 672 157.5],...
			'Name','FitData 1.0','Tag','Figure1','NumberTitle','off',...
			'Resize','off','Menubar','none',...
			'Color',[0.85 0.85 0.85]);
		%Plot figure
		figure('Units','Pixels',...
			'Position',[0.3*Monitor(3) 0.25*Monitor(4) 0.4*Monitor(3) 0.4*Monitor(4)],...
			'Name','Plot','Tag','Figure2','NumberTitle','off','CloseRequestFcn','FitData runClose',...
			'Resize','on','Visible','off',...
			'Color',[0.8 0.8 0.8]);
		%Plot zoom
		figure('Units','Pixels',...
			'Position',[0.2*Monitor(3) 0.065*Monitor(4) 0.6*Monitor(3) 0.6*Monitor(4)],...
			'Name','Zoom','Tag','Figure3','NumberTitle','off','CloseRequestFcn','FitData zoomClose',...
			'Resize','on','Visible','off',...
			'Color',[0.8 0.8 0.8]);
		figure(F1) %F1 is active
		
		% Push load - pl
		uicontrol(F1,'Units','Pixels','Style','Push',...
			'Position',[17 85 80 28],'Tag','load','String','Load data',...
			'ForegroundColor','black','BackgroundColor',[0.7 0.7 0.8],...
			'CallBack','FitData load',...
			'FontWeight','bold','FontSize',10);
		% Push preview - pp
		uicontrol(F1,'Units','Pixels','Style','Push',...
			'Position',[17 50 80 28],'Tag','preview','String','Preview',...
			'ForegroundColor','black','BackgroundColor',[0.7 0.7 0.8],...
			'CallBack','FitData preview','Enable','off',...
			'FontWeight','bold','FontSize',10);
		% Push zoom - pz
		uicontrol(F1,'Units','Pixels','Style','Push',...
			'Position',[17 15 80 28],'Tag','zoom','String','Zoom',...
			'ForegroundColor','black','BackgroundColor',[0.7 0.7 0.8],...
			'CallBack','FitData zoom','Enable','off',...
			'FontWeight','bold','FontSize',10);
		% Push run - pr
		uicontrol(F1,'Units','Pixels','Style','Push',...
			'Position',[575 85 80 28],'Tag','run','String','Run',...
			'ForegroundColor','black','BackgroundColor',[0.7 0.7 0.8],...
			'CallBack','FitData run','Enable','off',...
			'FontWeight','bold','FontSize',10);
		% Push save - ps
		uicontrol(F1,'Units','Pixels','Style','Push',...
			'Position',[575 50 80 28],'Tag','save','String','Save data',...
			'ForegroundColor','black','BackgroundColor',[0.7 0.7 0.8],...
			'CallBack','FitData save','Enable','off',...
			'FontWeight','bold','FontSize',10);
		% Push exit - pe
		uicontrol(F1,'Units','Pixels','Style','Push',...
			'Position',[575 15 80 28],'Tag','exit','String','Exit',...
			'ForegroundColor','black','BackgroundColor',[1 0.6 0.6],...
			'CallBack','FitData exit',...
			'FontWeight','bold','FontSize',10);
		
% 		% Text column selection
% 		uicontrol('Units','Normalized','Style','Text',...
% 			'Position',[0.05 0.735 0.17 0.18],'Tag','text3',...
% 			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
% 			'HorizontalAlignment','left',...
% 			'String','Column selection','FontWeight','bold','FontSize',10);
		% Text X
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[161 116 47 28],'Tag','text3',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'String','axis x:','FontWeight','bold','FontSize',10);
		% Text Y
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[161 81 47 28],'Tag','text4',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'String','axis y:','FontWeight','bold','FontSize',10);
		% Popup X - px
		uicontrol(F1,'Units','Pixels','Style','Popup',...
			'Position',[212 120 168 28],'Tag','popupx','String','x',...
			'ForegroundColor','black','BackgroundColor','white',...
			'Enable','off','CallBack','FitData run',...
			'FontWeight','bold','FontSize',10);
		% Popup Y - py
		uicontrol(F1,'Units','Pixels','Style','Popup',...
			'Position',[212 85 168 28],'Tag','popupy','String','y',...
			'ForegroundColor','black','BackgroundColor','white',...
			'Enable','off','CallBack','FitData run',...
			'FontWeight','bold','FontSize',10);
		
		% Edit text - X1 - e1
		uicontrol('Units','Pixels','Style','Edit',...
			'Position',[114 50 47 28],'Tag','edit1',...
			'ForegroundColor','black','BackgroundColor','white',...
			'Enable','off','CallBack','FitData edit',...
			'FontWeight','bold','FontSize',10);
		% Edit text - X2 - e2
		uicontrol('Units','Pixels','Style','Edit',...
			'Position',[114 15 47 28],'Tag','edit2',...
			'ForegroundColor','black','BackgroundColor','white',...
			'Enable','off','CallBack','FitData edit',...
			'FontWeight','bold','FontSize',10);
		% Slider X1 - s1
		uicontrol(F1,'Units','Pixels','Style','Slider',...
			'Position',[178 50 202 28],'Tag','slider1',...
			'Enable','off','CallBack','FitData slider');
		% Slider X2 - s2
		uicontrol(F1,'Units','Pixels','Style','Slider',...
			'Position',[178 15 202 28],'Tag','slider2',...
			'Enable','off','CallBack','FitData slider');
		
		% Frame - coordinates
		uicontrol('Style','frame','Units','Pixels',...
			'Position',[390 8 171 86],'Tag','FrameMode',...
			'BackgroundColor',get(gcf,'Color'));
		% Text coordinates
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[396 74 87 28],'Tag','textP1',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'String',' Coordinates:','FontWeight','bold','FontSize',10);
		% Text point 1
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[396 46 20 28],'Tag','textP1',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'String','P1:','FontWeight','bold','FontSize',10);
		% Text point 1  x - tp1x
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[430 46 57 28],'Tag','textP1x',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'FontWeight','bold','FontSize',10);
		% Text point 1  y - tp1y
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[497 46 57 28],'Tag','textP1y',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'FontWeight','bold','FontSize',10);
		% Text point 2
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[396 12 20 28],'Tag','textP2',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'String','P2:','FontWeight','bold','FontSize',10);
		% Text point 2 x - tp2x
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[430 12 57 28],'Tag','textP2x',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'FontWeight','bold','FontSize',10);
		% Text point 2 y - tp2y
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[497 12 57 28],'Tag','textP2y',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'FontWeight','bold','FontSize',10);
		
		% Text smoothing
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[396 116 87 28],'Tag','textSmooth',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'String',' Smoothing:','FontWeight','bold','FontSize',10);
		% Edit text smoothing
		uicontrol('Units','Pixels','Style','Edit',...
			'Position',[480 120 47 28],'Tag','editSmooth',...
			'ForegroundColor','black','BackgroundColor','white',...
			'Enable','off','CallBack','FitData smooth',...
			'String','1',...
			'FontWeight','bold','FontSize',10);
% 		575 15 80 28
		% Text Mean square error
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[530 116 45 28],'Tag','textMSE',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','left',...
			'String',' RMSE:','FontWeight','bold','FontSize',10);
		% Mean square error - value
		uicontrol('Units','Pixels','Style','Text',...
			'Position',[575 116 80 28],'Tag','valueMSE',...
			'ForegroundColor','black','BackgroundColor',get(gcf,'Color'),...
			'HorizontalAlignment','right',...
			'FontWeight','bold','FontSize',10);
	
	else %Funtion FitData with input parametr
		switch(vstpar)
			case('load')
				F1 = findobj('Tag','Figure1');
				pr = findobj('Tag','run');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				
				[file,directory]=uigetfile({'*.txt','Text Files (*.txt)';'*.dat','Data Files (*.dat)';'*.*','All Files (*.*)'},'Load');
				if file == 0
					return
				else
					A = importdata([directory, file]);
				end
				
				if (isnumeric(A) == 1 && isstruct(A) == 0)
					m = size(A,2);
					set(px,'Enable','on','String',num2str((1:m)'),'Value',1); %3
					set(py,'Enable','on','String',num2str((1:m)'),'Value',2); %1
					set(F1,'UserData',A);
					set(px,'UserData',A);
					set(pr,'Enable','on');	
				elseif (isfield(A,'colheaders') == 0 && isfield(A,'data') == 1)
					m = size(A.data,2);
					set(px,'Enable','on','String',num2str((1:m)'),'Value',1); %3
					set(py,'Enable','on','String',num2str((1:m)'),'Value',2); %1
					A = A.data;
					set(F1,'UserData',A);
					set(px,'UserData',A);
					set(pr,'Enable','on');
				elseif (isfield(A,'data') == 1)
					set(px,'Enable','on','String',A.colheaders','Value',1); %3
					set(py,'Enable','on','String',A.colheaders','Value',2); %1
					A = A.data;
					set(F1,'UserData',A);
					set(px,'UserData',A);
					set(pr,'Enable','on');
				end

			case('run')
				% F1 = findobj('Tag','Figure1');
				F2 = findobj('Tag','Figure2');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				s1 = findobj('Tag','slider1');
				s2 = findobj('Tag','slider2');
				e1 = findobj('Tag','edit1');
				e2 = findobj('Tag','edit2');
				tp1x = findobj('Tag','textP1x');
				tp1y = findobj('Tag','textP1y');
				tp2x = findobj('Tag','textP2x');
				tp2y = findobj('Tag','textP2y');
				ps = findobj('Tag','save');
				pp = findobj('Tag','preview');
				pz = findobj('Tag','zoom');
				e3 =  findobj('Tag','editSmooth');
								
				set(F2,'Visible','on');
				set(ps,'Enable','on');
				set(pp,'Enable','on');
				set(pz,'Enable','on');
				set(e3,'Enable','on');
				
				figure(F2);
				A = get(px,'UserData');
				n = size(A,1);
				%m = size(A,2);
				cx = get(px,'Value');
				cy = get(py,'Value');
				set(s1,'Enable','on','Min',1,'Max',n,'Value',1,'SliderStep',[1/(n-1) 10/(n-1.001)]);
				set(s2,'Enable','on','Min',1,'Max',n,'Value',round(n/2),'SliderStep',[1/(n-1) 10/(n-1.001)]);
				set(e1,'Enable','on','String',get(s1,'Value'));
				set(e2,'Enable','on','String',get(s2,'Value'));
				set(tp1x,'String',strcat(sprintf('%.4f',A(get(s1,'Value'),cx))));
				set(tp2x,'String',strcat(sprintf('%.4f',A(get(s2,'Value'),cx))));
				set(tp1y,'String',strcat(sprintf('%.4f',A(get(s1,'Value'),cy))));
				set(tp2y,'String',strcat(sprintf('%.4f',A(get(s2,'Value'),cy))));
				
				FitData Draw;
				
			case('Draw')
				% F1 = findobj('Tag','Figure1');
				F2 = findobj('Tag','Figure2');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				s1 = findobj('Tag','slider1');
				s2 = findobj('Tag','slider2');
				vMSE = findobj('Tag','valueMSE');
				
				figure(F2);
				A = get(px,'UserData');
				%n=size(A,1);
				m = size(A,2);
				cx = get(px,'Value');
				cy = get(py,'Value');
				mins = min(get(s1,'Value'),get(s2,'Value'));
				maxs = max(get(s1,'Value'),get(s2,'Value'));
		
				if get(s1,'Value') ~= get(s2,'Value')
					B = zeros(abs(maxs-mins)+1,m+1);
					B(:, 1:m) = A(mins:maxs, :);
					p = polyfit(B(:,cx), B(:,cy),1);
					B(:, m+1) = polyval(p, B(:,cx));
					% set(F2,'UserData',B);
					set(s1,'UserData',p);
					MSE = sqrt( sum( ( A(mins:maxs, cy) - B(:, m+1)).^2) / (abs(maxs-mins)+1));
					set(vMSE,'String',strcat(sprintf('%.4f',MSE)));
					
					plot(A(:,cx),A(:,cy));
					hold on
					grid on
					plot(B(:,cx), B(:,m+1),'r','LineWidth',2);
					plot(A(get(s1,'Value'),cx),A(get(s1,'Value'),cy),'ro');
					plot(A(get(s2,'Value'),cx),A(get(s2,'Value'),cy),'ro');
					hold off
				end
			
			case('slider')
				% F1 = findobj('Tag','Figure1');
				F2 = findobj('Tag','Figure2');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				s1 = findobj('Tag','slider1');
				s2 = findobj('Tag','slider2');
				e1 = findobj('Tag','edit1');
				e2 = findobj('Tag','edit2');
				tp1x = findobj('Tag','textP1x');
				tp1y = findobj('Tag','textP1y');
				tp2x = findobj('Tag','textP2x');
				tp2y = findobj('Tag','textP2y');
				
				figure(F2);
				set(s1,'Value',round(get(s1,'Value')));
				set(s2,'Value',round(get(s2,'Value')));
				A = get(px,'UserData');
				%n = size(A,1);
				%m = size(A,2);
				cx = get(px,'Value');
				cy = get(py,'Value');
				set(e1,'Enable','on','String',get(s1,'Value'));
				set(e2,'Enable','on','String',get(s2,'Value'));
				set(tp1x,'String',strcat(sprintf('%.4f',A(get(s1,'Value'),cx))));
				set(tp2x,'String',strcat(sprintf('%.4f',A(get(s2,'Value'),cx))));
				set(tp1y,'String',strcat(sprintf('%.4f',A(get(s1,'Value'),cy))));
				set(tp2y,'String',strcat(sprintf('%.4f',A(get(s2,'Value'),cy))));
				
				FitData Draw;
				
			case('edit')
				% F1 = findobj('Tag','Figure1');
				F2 = findobj('Tag','Figure2');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				s1 = findobj('Tag','slider1');
				s2 = findobj('Tag','slider2');
				e1 = findobj('Tag','edit1');
				e2 = findobj('Tag','edit2');
				tp1x = findobj('Tag','textP1x');
				tp1y = findobj('Tag','textP1y');
				tp2x = findobj('Tag','textP2x');
				tp2y = findobj('Tag','textP2y');
				
				figure(F2);
				set(e1,'String',(round(str2double(get(e1,'String')))));
				set(e2,'String',(round(str2double(get(e2,'String')))));
				
				A = get(px,'UserData');
				n = size(A,1);
				%m = size(A,2);
				cx = get(px,'Value');
				cy = get(py,'Value');
				
				%Set limits
				set(e1,'String',max(str2double(get(e1,'String')),1));
				set(e1,'String',min(str2double(get(e1,'String')),n));
				set(e2,'String',max(str2double(get(e2,'String')),1));
				set(e2,'String',min(str2double(get(e2,'String')),n));
				
				set(s1,'Value',str2double(get(e1,'String')));
				set(s2,'Value',str2double(get(e2,'String')));
				set(tp1x,'String',strcat(sprintf('%.4f',A(get(s1,'Value'),cx))));
				set(tp2x,'String',strcat(sprintf('%.4f',A(get(s2,'Value'),cx))));
				set(tp1y,'String',strcat(sprintf('%.4f',A(get(s1,'Value'),cy))));
				set(tp2y,'String',strcat(sprintf('%.4f',A(get(s2,'Value'),cy))));
				
				FitData Draw;
			
			case('smooth')
				F1 = findobj('Tag','Figure1');
				F2 = findobj('Tag','Figure2');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				ets = findobj('Tag','editSmooth');
				
				figure(F2);
				A = get(F1,'UserData');
				As = get(F1,'UserData'); %px
				cx = get(px,'Value');
				cy = get(py,'Value');
				
				smooLen = str2double(get(ets,'String'));
				if isnumeric(smooLen) == 1 && smooLen>=1
					set(ets,'String',(round(str2double(get(ets,'String')))));
					smooLen = str2double(get(ets,'String'));
				else
					set(ets,'String',1);
					smooLen = str2double(get(ets,'String'));
				end
				As(:, cy) = smooth(A(:, cy), smooLen,'lowess');
				set(px,'UserData',As);
				
				plot(A(:,cx),A(:,cy),'.-', 'Color', [0.6 0.6 0.6] ,'LineWidth',0.1,'MarkerEdgeColor','r','MarkerSize',1);
				hold on
				FitData Draw;
				
			case('preview')	
				% F1 = findobj('Tag','Figure1');
				F2 = findobj('Tag','Figure2');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				s1 = findobj('Tag','slider1');
				s2 = findobj('Tag','slider2');
				
				figure(F2);
				A = get(px,'UserData');
				p = get(s1,'UserData');
				n = size(A,1);
				m = size(A,2);
				cx = get(px,'Value');
				cy = get(py,'Value');
				mins = min(get(s1,'Value'),get(s2,'Value'));
				% maxs = max(get(s1,'Value'),get(s2,'Value'));
				
				C = zeros(size(A,1)-mins+2,m);
				C(2:size(C,1),:) = A(mins:n,:);
				C(1,cy) = 0;

				C(1,cx)=-p(1,2)/p(1,1);
				C(:,cx)=C(:,cx)-C(1,cx);
				
				hold on
				plot(C(:,cx),C(:,cy),'r');
				hold off
				
			case('zoom')
				% F1 = findobj('Tag','Figure1');
				% F2 = findobj('Tag','Figure2');
				F3 = findobj('Tag','Figure3');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				s1 = findobj('Tag','slider1');
				s2 = findobj('Tag','slider2');
					
				set(F3,'Visible','on');
				figure(F3);
				A=get(px,'UserData');
				%n=size(A,1);
				m=size(A,2);
				cx=get(px,'Value');
				cy=get(py,'Value');
				mins=min(get(s1,'Value'),get(s2,'Value'));
				maxs=max(get(s1,'Value'),get(s2,'Value'));
				
				if get(s1,'Value')~=get(s2,'Value')
					B=zeros(abs(maxs-mins)+1,m+1);
					B(:,1:m)=A(mins:maxs,:);
					p=polyfit(B(:,cx),B(:,cy),1);
					B(:,m+1)=polyval(p,B(:,cx));
					% set(F2,'UserData',B);
					set(s1,'UserData',p);
				
					plot(A(:,cx),A(:,cy));
					xlim([min(A(get(s1,'Value'),cx),A(get(s2,'Value'),cx)) max(A(get(s1,'Value'),cx),A(get(s2,'Value'),cx))]);
					hold on
					grid on
					plot(B(:,cx),B(:,m+1),'r','LineWidth',2);
					plot(A(get(s1,'Value'),cx),A(get(s1,'Value'),cy),'ro');
					plot(A(get(s2,'Value'),cx),A(get(s2,'Value'),cy),'ro');
					hold off
				end
				
			case('runClose')
				F2 = findobj('Tag','Figure2');
				set(F2,'Visible','off');
				
			case('zoomClose')
				F3 = findobj('Tag','Figure3');
				set(F3,'Visible','off');
				
			case('save')
				% F1 = findobj('Tag','Figure1');
				px = findobj('Tag','popupx');
				py = findobj('Tag','popupy');
				s1 = findobj('Tag','slider1');
				s2 = findobj('Tag','slider2');
				
				A = get(px,'UserData');
				p = get(s1,'UserData');
				n = size(A,1);
				m = size(A,2);
				cx = get(px,'Value');
				cy = get(py,'Value');	
				mins = min(get(s1,'Value'),get(s2,'Value'));
				% maxs = max(get(s1,'Value'),get(s2,'Value'));
				
				C = zeros(size(A,1)-mins+2,m);
				C(2:size(C,1),:) = A(mins:n,:);
				C(1,cy) = 0;
				
				C(1,cx)=-p(1,2)/p(1,1);
				C(:,cx)=C(:,cx)-C(1,cx);
		
                [file,directory]=uiputfile({'*.txt','Text Files (*.txt)';'*.dat','Data Files (*.dat)';'*.*','All Files (*.*)'},'Save');
				
                if (file==0)
                else
                    save([directory,file],'C','-ascii');
				end
				
			case('exit')
				F2 = findobj('Tag','Figure2');
				F3 = findobj('Tag','Figure3');
				
				delete(F2);
				delete(F3);
				close all;
		end
	end
end